﻿using DevExpress.Xpo;
using XpoOneWayMultiAssociations;

namespace Tests
{
   [AllowXpoOneWayAssociations]
   public class Customer : XPObject
   {
      #region Constructors

      public Customer(Session session) : base(session)
      {
      }

      public Customer()
      {
      }

      #endregion

      #region Fields

      private string name;

      #endregion

      #region Properties

      public string Name
      {
         get { return name; }
         set { SetPropertyValue("Name", ref name, value); }
      }

      //[Association("CustomerOrders")]
      public XPCollection<Order> Orders
      {
         get { return GetCollection<Order>("Orders"); }
      }

      #endregion
   }

   [AllowXpoOneWayAssociations]
   public class Order : XPObject
   {
      #region Constructors

      public Order(Session session) : base(session)
      {
      }

      public Order()
      {
      }

      #endregion

      #region Fields

      private string name;

      #endregion

/*
 * You would usually need a property or field with an association attribute, as shown.
      [Association("CustomerOrders")]
      public Customer Customer;
*/

      #region Properties

      public string Name
      {
         get { return name; }
         set { SetPropertyValue("Name", ref name, value); }
      }

      #endregion
   }
}