// Copyright  Sean Kearon, Atlantic Business Systems.  All rights reserved.
using System;
using PostSharp.Laos;

namespace XpoOneWayMultiAssociations
{
   /// <summary>
   /// This aspect notifies postsharp that the weaver needs to be called.
   /// </summary>
   [Serializable]
   public class OtherEndFieldSubAspect : ILaosTypeLevelAspect
   {
      #region Constructors

      /// <summary>
      /// Initializes a new instance of the <see cref="OtherEndFieldSubAspect"/> class.
      /// </summary>
      /// <param name="fieldTypeName">Name of the field type.</param>
      /// <param name="fieldName">Name of the field.</param>
      /// <param name="associationName">Name of the association.</param>
      public OtherEndFieldSubAspect(string fieldTypeName, string fieldName, string associationName)
      {
         FieldTypeName = fieldTypeName;
         FieldName = fieldName;
         AssociationName = associationName;
      }

      #endregion

      #region Methods

      public void CompileTimeInitialize(Type type)
      {
      }

      public bool CompileTimeValidate(Type type)
      {
         return true;
      }

      public void RuntimeInitialize(Type type)
      {
      }

      #endregion

      #region Properties

      public int AspectPriority
      {
         get { return int.MinValue; }
      }

      public string AssociationName { get; set; }
      public string FieldName { get; set; }
      public string FieldTypeName { get; set; }

      #endregion
   }
}